//+------------------------------------------------------------------+
//|                                                 PosizionSize.mq4 |
//|                                         Copyright  2010, Xaphod |
//|                                     http://forexwhiz.appspot.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Xaphod"
#property link      "http://forexwhiz.appspot.com"

#property indicator_chart_window


extern double Risk=2.0;       //Percent of free margin to risk
extern bool   AutoDigit=true;  //Check and adjust for fractiona pips (5 digit brokers)
extern int    FractionalPip=1;   //Value of one point in non-fractional pips. 4digitbroker=1, 5digitbroker=10 etc.

int iPoint;

//-----------------------------------------------------------------------------
// function: init()
//-----------------------------------------------------------------------------
int init()
{
  // Init vars
  if (AutoDigit)
    iPoint=SetPoint();
  else
    iPoint = FractionalPip;
  
  return(0);
}

//-----------------------------------------------------------------------------
// function: deinit()
//-----------------------------------------------------------------------------
int deinit() {
  // Init vars
  Comment("");
  return(0);
}

//-----------------------------------------------------------------------------
// function: start()
//-----------------------------------------------------------------------------
int start() {
 // double dLotSize;
  
  Comment("\nFree Margin="+DoubleToStr(AccountFreeMargin(),0)+
             "\nRisk Level="+DoubleToStr(Risk,1)+"%"+
             "\n\nSL="+10*iPoint+", LotSize="+DoubleToStr(CalcLotSize(10,Risk),2)+
             "\nSL="+15*iPoint+", LotSize="+DoubleToStr(CalcLotSize(15,Risk),2)+
             "\n\nSL="+20*iPoint+", LotSize="+DoubleToStr(CalcLotSize(20,Risk),2)+
             "\nSL="+25*iPoint+", LotSize="+DoubleToStr(CalcLotSize(25,Risk),2)+
             "\n\nSL="+30*iPoint+", LotSize="+DoubleToStr(CalcLotSize(30,Risk),2)+
             "\nSL="+40*iPoint+", LotSize="+DoubleToStr(CalcLotSize(40,Risk),2)+
             "\nSL="+50*iPoint+", LotSize="+DoubleToStr(CalcLotSize(50,Risk),2));
  return(0);
}

//-----------------------------------------------------------------------------
// function: CalcLotSize()
// Description: Calc Lot Size based on risk setting
//-----------------------------------------------------------------------------
double CalcLotSize(int iSL,double dRisk)
{    
  double dBalance;
  double dRiskCapital;
  
  dBalance=AccountFreeMargin();
  dRiskCapital=dRisk/100*dBalance;
  return( dRiskCapital/(iSL*MarketInfo(Symbol(),MODE_TICKVALUE)*iPoint));
}

//-----------------------------------------------------------------------------
// function: SetPoint()
// Description: Set 4/5 digit broker
//-----------------------------------------------------------------------------
int SetPoint()
{
   if (Digits==3 || Digits==5) return(10); 
   else return(1);            
} // end funcion()
  